%global gitdate     20131006
%global commit      c72c945ba8e18e68e5650e7e4982b86e558abe6c
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           mathicgb
Version:        1.0
Release:        2.%{gitdate}.git%{shortcommit}%{?dist}
Summary:        Groebner basis computations

License:        GPLv2+
URL:            https://github.com/broune/mathicgb
Source0:        https://github.com/broune/mathicgb/archive/%{commit}/%{name}-%{shortcommit}.tar.gz

BuildRequires:  gtest-devel
BuildRequires:  libtool
BuildRequires:  memtailor-devel
BuildRequires:  mathic-devel
# Using TBB leads to segfaults and hangs on i386.
# Disable until we understand why.
# BuildRequires:  tbb-devel

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description
Mathicgb is a program for computing Groebner basis and signature Grobner
bases.  Mathicgb is based on the fast data structures from mathic.

%package devel
Summary:        Development files for mathicgb
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description devel
Files for developing applications that use mathicgb.

%package libs
Summary:        Mathicgb libraries

%description libs
Library interface to mathicgb.

%prep
%setup -q -n %{name}-%{commit}

# Fix end-of-line encoding
sed -i.orig 's/\r//' doc/description.txt
touch -r doc/description.txt.orig doc/description.txt
rm -f doc/description.txt.orig

# Nearly every file is marked executable; only a few need to be.
find . -type f -perm /0111 | xargs chmod a-x
chmod a+x autogen.sh fixspace replace build/setup/make-Makefile.sh

# Fool the configure script into not downloading gtest
sed -e 's,gtest/src/gtest-all\.cc,include/gtest/gtest.h,' \
    -e 's,gtest/include,include/gtest,' \
    -e 's,-I`cd \$GTEST_PATH/gtest/; echo \$PWD`,,' \
    -i configure.ac

# Fool the tests into not compiling with gtest source
sed -i 's,\.\./src/gtest-all\.cc,gtest/gtest.h,' src/test/gtestInclude.cpp

# Link tests with the installed gtest library
sed -i 's/unittest_LDADD.*/& -lgtest/' Makefile.am

# Upstream doesn't generate the configure script
./autogen.sh

%build
export GTEST_PATH=%{_prefix}
export GEST_LIBS="-lgtest"
export GTEST_VERSION=$(gtest-config --version)
export CFLAGS="%{optflags} -fwrapv -fsigned-char"
export CXXFLAGS="%{optflags} -fwrapv -fsigned-char"
%configure --disable-static --with-gtest=yes

# Get rid of undesirable hardcoded rpaths; workaround libtool reordering
# -Wl,--as-needed after all the libraries.
sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|CC=.g..|& -Wl,--as-needed|' \
    -i libtool

make %{?_smp_mflags}

%install
%make_install

# We don't want the libtool archive
rm -f %{buildroot}%{_libdir}/lib%{name}.la

%check
export LD_LIBRARY_PATH=$PWD/.libs
make check

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files
%doc README.md doc/description.txt doc/slides.pdf
%{_bindir}/mgb

%files devel
%{_includedir}/%{name}.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc

%files libs
%{_libdir}/lib%{name}.so.*

%changelog
* Tue Dec  1 2015 Jerry James <loganjerry@gmail.com> - 1.0-2.20131006.gitc72c945
- Do not use TBB for now

* Tue Dec  1 2015 Jerry James <loganjerry@gmail.com> - 1.0-1.20131006.gitc72c945
- Initial RPM
